From 92ee4d72ace83e02ec3b714e13de695fa4f15f01 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Laur=C3=A9line=20Gu=C3=A9rin?= <zebuline@entrouvert.com>
Date: Fri, 10 Sep 2021 10:28:08 +0200
Subject: [PATCH] toodego: add tryauth in caluire eservices urls (#56812)

---
 templates/combo/json/caluire-enfant-agenda.html | 2 +-
 templates/combo/json/caluire-enfant.html        | 2 +-
 templates/combo/json/caluire-famille.html       | 6 +++---
 templates/combo/json/caluire-responsables.html  | 6 +++---
 4 files changed, 8 insertions(+), 8 deletions(-)

diff --git a/templates/combo/json/caluire-enfant-agenda.html b/templates/combo/json/caluire-enfant-agenda.html
index e57b1729..64ff959c 100644
--- a/templates/combo/json/caluire-enfant-agenda.html
+++ b/templates/combo/json/caluire-enfant-agenda.html
@@ -29,7 +29,7 @@
   {% endwith %}
 {% if day.weekday == 6 %}
 </ul>
-<p class="booking-btn"><a class="pk-button" href="{{ eservices_url }}famille/gerer-mes-reservations/?child_id={{ child_id }}&reference_year={{ first_monday.year }}&current={{ day|adjust_to_week_monday|date:"Y-m-d" }}">Modifier l'agenda</a></p>
+<p class="booking-btn"><a class="pk-button" href="{{ eservices_url }}famille/gerer-mes-reservations/tryauth?child_id={{ child_id }}&reference_year={{ first_monday.year }}&current={{ day|adjust_to_week_monday|date:"Y-m-d" }}">Modifier l'agenda</a></p>
 <p class="no-activity">Pas d'activité cette semaine</p>
 </li>
 {% endif %}
diff --git a/templates/combo/json/caluire-enfant.html b/templates/combo/json/caluire-enfant.html
index 0026e162..6819a166 100644
--- a/templates/combo/json/caluire-enfant.html
+++ b/templates/combo/json/caluire-enfant.html
@@ -8,7 +8,7 @@
     {% if schooling.data.SCOLAIRE %}
     Ecole : {{ schooling.data.SCOLAIRE.LIBELLEECOLE }} <br/>
     Classe : {{ schooling.data.SCOLAIRE.IDENTNIVEAU }}<br/>
-    <p><a href="{{ eservices_url }}famille/modifier-mon-dossier-unique-sante-de-mon-enfant/">Modifier une donnée de santé</a></p>
+    <p><a href="{{ eservices_url }}famille/modifier-mon-dossier-unique-sante-de-mon-enfant/tryauth">Modifier une donnée de santé</a></p>
 {% endif %}
 </div><div class="grid-1-2">
     <p><b> Les inscriptions en cours</b></p>
diff --git a/templates/combo/json/caluire-famille.html b/templates/combo/json/caluire-famille.html
index 9826fb68..ee9ee78b 100644
--- a/templates/combo/json/caluire-famille.html
+++ b/templates/combo/json/caluire-famille.html
@@ -2,12 +2,12 @@
 <div>
 <p>Identifiant famille </br>
 <b>n° {{ json.data.RESPONSABLE1.FAMILLE.0.IDENTFAMILLE }}</b></br>
-<a href="{{ eservices_url }}famille/supprimer-le-lien-avec-mon-compte-famille/">Supprimer la liaison avec mon dossier famille</a></p>
+<a href="{{ eservices_url }}famille/supprimer-le-lien-avec-mon-compte-famille/tryauth">Supprimer la liaison avec mon dossier famille</a></p>
 
 <p><b>Adresse</b></br>
 {{ json.data.RESPONSABLE1.ADRESSE.NORUE|default:"" }} {{ json.data.RESPONSABLE1.ADRESSE.ADRESSE1|default:"" }}</br> 
 {{ json.data.RESPONSABLE1.ADRESSE.CODEPOSTAL|default:"" }} {{ json.data.RESPONSABLE1.ADRESSE.VILLE|default:"" }}</br>
-<a href="{{ eservices_url }}famille/modifier-mon-dossier-unique-changement-d-adresse/">Modifier l'adresse</a></br></br></br></br></br></br></p>
+<a href="{{ eservices_url }}famille/modifier-mon-dossier-unique-changement-d-adresse/tryauth">Modifier l'adresse</a></br></br></br></br></br></br></p>
 
-<p><a class="pk-button" href="{{ eservices_url }}famille/modifier-mon-dossier-unique-autre-changement/">Autre changement</a></p>
+<p><a class="pk-button" href="{{ eservices_url }}famille/modifier-mon-dossier-unique-autre-changement/tryauth">Autre changement</a></p>
 </div>
diff --git a/templates/combo/json/caluire-responsables.html b/templates/combo/json/caluire-responsables.html
index 92f88e10..12e2b3d3 100644
--- a/templates/combo/json/caluire-responsables.html
+++ b/templates/combo/json/caluire-responsables.html
@@ -4,13 +4,13 @@
 <p>{{ json.data.RESPONSABLE1.CIVILITE|default:"" }} {{ json.data.RESPONSABLE1.PRENOM|default:"" }} {{ json.data.RESPONSABLE1.NOM|default:"" }}</br>
 Tél : {{ json.data.RESPONSABLE1.TELFIXE|default:"" }} / Mob : {{ json.data.RESPONSABLE1.TELPORTABLE|default:"" }}</br>
 Courriel : {{ json.data.RESPONSABLE1.MAIL|default:"" }}</br>
-<a href="{{ eservices_url }}famille/modifier-mon-dossier-unique-telephone-et-courriel/">Modifier le téléphone ou courriel</a></p>
+<a href="{{ eservices_url }}famille/modifier-mon-dossier-unique-telephone-et-courriel/tryauth">Modifier le téléphone ou courriel</a></p>
 
 <p><b>Responsable du foyer</b>
 <p>{{ json.data.RESPONSABLE2.CIVILITE|default:"" }} {{ json.data.RESPONSABLE2.PRENOM|default:"" }} {{ json.data.RESPONSABLE2.NOM|default:"" }}</br>
 Tél : {{ json.data.RESPONSABLE2.TELFIXE|default:"" }} / Mob : {{ json.data.RESPONSABLE2.TELPORTABLE|default:"" }}</br>
 Courriel : {{ json.data.RESPONSABLE2.MAIL|default:"" }}</br>
-<a href="{{ eservices_url }}famille/modifier-mon-dossier-unique-telephone-et-courriel/">Modifier le téléphone ou courriel</a></p>
+<a href="{{ eservices_url }}famille/modifier-mon-dossier-unique-telephone-et-courriel/tryauth">Modifier le téléphone ou courriel</a></p>
 
-<p><a class="pk-button" href="{{ eservices_url }}famille/modifier-mon-dossier-unique-changement-de-situation-familiale/">Changement de situation familiale</a></p>
+<p><a class="pk-button" href="{{ eservices_url }}famille/modifier-mon-dossier-unique-changement-de-situation-familiale/tryauth">Changement de situation familiale</a></p>
 </div>
-- 
2.30.2